<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Struct Annote Defs</TITLE>
<link href="suif1_82.html" rel=Next>
<link href="suif1_80.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_80.html">previous</A>, <A HREF="suif1_82.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H3><A NAME="SEC81" HREF="suif1_toc.html#TOC81">Structured Annotation Definitions</A></H3>
<P>
<A NAME="IDX593"></A>
<A NAME="IDX594"></A>
<A NAME="IDX595"></A>

</P>
<P>
<A NAME="IDX596"></A>
The <CODE>struct_annote_def</CODE> class, which is derived from the
<CODE>annote_def</CODE> class, is used to record the definitions of structured
annotations.  Objects of this class behave just like base
<CODE>annote_def</CODE> objects, except the <CODE>is_structured</CODE> method
returns <CODE>TRUE</CODE>.  In addition, these objects contain pointers to
four functions:

</P>
<DL COMPACT>

<DT><CODE>from</CODE>
<DD>
<A NAME="IDX597"></A>
The <CODE>from</CODE> function converts the annotation data from a list of
<CODE>immed</CODE> values to the user's data structure.  This function is
required.

<DT><CODE>to</CODE>
<DD>
<A NAME="IDX598"></A>
The <CODE>to</CODE> function converts the user's data structure to a list of
<CODE>immed</CODE> values.  This function is required.

<DT><CODE>free</CODE>
<DD>
<A NAME="IDX599"></A>
The <CODE>free</CODE> function is optional, but it should be provided if the
annotation data needs to be deallocated when the annotation is deleted.

<DT><CODE>print</CODE>
<DD>
<A NAME="IDX600"></A>
The <CODE>print</CODE> function is also optional, but without it the data in a
structured annotation is simply printed as a hexadecimal value.  This
function allows you to print the annotations in more meaningful formats.
As much as possible, the annotations should be printed in the same style
as flat annotations.
</DL>

<P>
<A NAME="IDX601"></A>
Structured annotations must be registered with the manager before the
SUIF input file is read.  Otherwise, the annotations will remain as
<CODE>immed</CODE> value lists, instead of being converted to the appropriate
data structures.  The <CODE>STRUCT_ANNOTE</CODE> macro should be used to
register structured annotations.  This is just like the <CODE>ANNOTE</CODE>
macro except that it takes four more arguments for the
<CODE>struct_annote_def</CODE> functions.  For example:

</P>

<PRE>
char *k_struct_annote;
void *ann_from(char *name, immed_list *il, suif_object *obj);
immed_list *ann_to(char *name, void *data);
void ann_free(void *data);

STRUCT_ANNOTE(k_struct_annote, "struct_annote", TRUE,
              ann_from, ann_to, ann_free, NULL);
</PRE>

<P>
This registers the annotation <CODE>"struct_annote"</CODE> as a structured
annotation.  The <CODE>ann_from</CODE> function will be used to convert the
annotation data from a list of <CODE>immed</CODE> values; the <CODE>ann_to</CODE>
function will be used to convert the data back to an <CODE>immed_list</CODE>;
and the <CODE>ann_free</CODE> function will be used to deallocate the
annotation data.  No function is provided to print the annotation data.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_80.html">previous</A>, <A HREF="suif1_82.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
